format MS COFF

public MakeTree as '_MakeTree@8'
public ClearTree as '_ClearTree@0'
public Find as '_Find@8'
public MemoryInit as '_MemoryInit@0'


include 'c:\fasm\INCLUDE\WIN32A.INC'
include 'struct.inc'
include 'memory.inc'


EndText 	dd	?
SuffFrom	dd	?
FullNode	dd	?
FullDepth	dd	?
LayText 	dd	?
TreeRoot	dd	?



; >>ebx
AddNode:
	call	NewNode
	mov	ebx,eax
	mov	eax,[TreeRoot]
	mov	[ebx+node_st.suff],eax
	push	ecx
	push	edi
	lea	edi,[ebx+node_st.links] 	; links=0   table=0
	xor	eax,eax
	mov	ecx,HASH_SIZE+1
	rep	stosd
	pop	edi
	pop	ecx
	ret



; ebx< node
; esi< start
; eax< end
; >> eax
AddLink:
	push	ebx
	push	ecx
	mov	ecx,eax
	call	NewLink
	mov	[eax+link_st.first],esi
	mov	[eax+link_st.last],ecx
	mov	ecx,dword  [ebx+node_st.links]		;   
	mov	dword [eax+link_st.next],ecx
	mov	[ebx+node_st.links],eax
	xor	ecx,ecx
	mov	[eax+link_st.node],ecx
	mov	[eax+link_st.p1],ecx
	mov	[eax+link_st.p2],ecx
	mov	cl,[esi]
	and	cl,HASH_SIZE-1
	lea	ebx,[ebx+ecx*4+node_st.table]
.1:	mov	ecx,[ebx]				;    
	jecxz	.2
	mov	ebx,[ecx+link_st.first]
	mov	bl,byte [ebx]
	cmp	[esi],bl
	sbb	ebx,ebx
	lea	ebx,[ebx*4+ecx+link_st.p2]
	jmp	.1
.2:	mov	[ebx],eax
	pop	ecx
	pop	ebx
	ret


; esi < text
; ecx < depth
; ebx < node
; edx - link
; edi - first
Lay:
	push	esi							;text
	add	esi,ecx
.0:	mov	al,byte [esi]
	mov	edx,HASH_SIZE-1
	and	edx,eax
	mov	edx,[ebx+edx*4+node_st.table]	;      
	jmp	.2
.1:	mov	edi,[edx+link_st.first] 	;    
	cmp	al,[edi]
	jz	.4
	sbb	edi,edi
	mov	edx,[edx+edi*4+link_st.p2]
.2:	test	edx,edx
	jnz	.1
	pop	eax
	mov	[FullNode],ebx
	mov	[LayText],eax
	neg	eax
	add	eax,esi
	mov	[FullDepth],eax
	xor	eax,eax
	call	AddLink
	mov	ecx,[SuffFrom]
	jecxz	.3
	mov	[ecx+node_st.suff],ebx
	xor	ecx,ecx
	mov	[SuffFrom],ecx
.3:	clc
	ret
.4:	mov	eax,[EndText]
	dec	eax
	sub	eax,esi 	
	mov	ecx,[edx+link_st.last]
;       jecxz   .5
	sub	ecx,edi
	cmp	ecx,eax 	 
	cmovc	eax,ecx
.5:	add	edi,eax
	add	esi,eax 	
	cmp	edi,[edx+link_st.last]	
	cmovz	ebx,[edx+link_st.node]
	jz	.0
	mov	al,[esi]
	cmp	al,[edi]
	jnz	.7
	pop	eax
	mov	ecx,[SuffFrom]
	jecxz	.6
	mov	[ecx+node_st.suff],ebx
	mov	[SuffFrom],ebx
.6:	stc
	ret
.7:	call	AddNode ; ebx>node
	mov	eax,[edx+link_st.last]
	push	esi
	mov	esi,edi
	call	AddLink 		
	mov	esi,[edx+link_st.node]
	mov	[eax+link_st.node],esi
	pop	esi
	xor	eax,eax
	call	AddLink
	pop	eax					
	mov	[LayText],eax
	neg	eax
	add	eax,esi
	mov	[FullDepth],eax
	mov	[FullNode],ebx
	mov	ecx,[SuffFrom]
	jecxz	.8
	mov	[ecx+node_st.suff],ebx
.8:	mov	[SuffFrom],ebx
	mov	[edx+link_st.last],edi
	mov	[edx+link_st.node],ebx
	clc
	ret


; esi < text
;; ebx - node
;; edx - link
;; edi - frist
proc Find pattern,size
	mov	esi,[pattern]
	mov	ecx,[size]
	mov	ebx,[TreeRoot]
.1:	jecxz	.ret
	movzx	eax,byte [esi]
	and	al,HASH_SIZE-1
	mov	edx,[ebx+eax*4+node_st.table]
	mov	al,[esi]
	jmp	.3
.2:	mov	edi,[edx+link_st.first]
	cmp	al,[edi]
	jz	.4
	sbb	edi,edi
	mov	edx,[edx+edi*4+link_st.p2]
.3:	test	edx,edx
	jnz	.2
.err:	xor	eax,eax
	ret
.4:	mov	ebx,ecx
	mov	eax,[edx+link_st.last]
	test	eax,eax
	cmovz	eax,[EndText]
	sub	eax,edi
	cmp	eax,ecx
	cmovnc	eax,ecx
	xchg	eax,ecx
	rep	cmpsb
	jnz	.err
	neg	eax
	lea	ecx,[ebx+eax]
	mov	ebx,[edx+link_st.node]
	jmp	.1
.ret:	mov	eax,edi
	sub	eax,[size]
	ret
endp



proc MakeTree text,size
	push	esi	       ;    VC  
	mov	eax,[text]
	mov	[LayText],eax
	mov	[EndText],eax
	call	AddNode
	mov	[TreeRoot],ebx
	mov	[FullNode],ebx
	mov	[ebx+node_st.suff],ebx
	mov	esi,[LayText]
	mov	edx,[size]
	add	edx,esi
	xor	ecx,ecx
	mov	[FullDepth],ecx
	jmp	.3
.1:	mov	[EndText],esi
	xor	eax,eax
	mov	[SuffFrom],eax
	mov	ebx,[FullNode]
	mov	ecx,[FullDepth]
	mov	esi,[LayText]
	jmp	.4
.2:     xor     eax,eax
        cmp     eax,ecx
        sbb     ecx,eax
	mov	ebx,[ebx+node_st.suff]
.3:	push	ebx
	push	ecx
	push	esi
	push	edx
	call	Lay
	pop	edx
	pop	esi
	pop	ecx
	pop	ebx
	jc	.5
.4:	inc	esi
	cmp	esi,[EndText]
	jc	.2
.5:	mov	esi,[EndText]
	inc	esi
	cmp	esi,edx
	jna	.1
	pop	esi
	mov	eax,[TreeRoot]
	ret
endp

ClearTree:
	jmp ClearMemory


